#!/usr/bin/python3

from script_utils import GroupsHandler, addScript

'''
(1) n, q <= 100
(2) bamboo
(3) q = 1
(4) binary tree
(5) only erases
(6) n, q <= 1e5
(7) n, q <= 3e5
'''

groupsHandler = GroupsHandler()

@groupsHandler.registerGroup(group=1, score=10)
def group1():
    addScript(n=2, q=1, tmode='random', qmode='random')
    for n in [3, 5, 10, 50, 100]:
        addScript(n=n, q=100, tmode='random', qmode='random')

    for subset in [3, 5, 10]:
        addScript(n=100, q=100, tmode='random', qmode='small_subset', subset=subset)
        addScript(n=100, q=100, tmode='looong', groups=23, qmode='small_subset', subset=subset)

    addScript(n=100, q=100, tmode='bamboo', qmode='bamboo_parity')
    addScript(n=100, q=100, tmode='looong', groups=35, qmode='random')

@groupsHandler.registerGroup(group=2, score=10)
def group2():
    N = 10**5
    for n in [10**3, 10**4, N]:
        addScript(n=n, q=N, tmode='bamboo', qmode='random')

    for subset in [2, 5, 10, 100, 1000]:
        addScript(n=N, q=N, tmode='bamboo', qmode='small_subset', subset=subset)

    addScript(n=N, q=N, tmode='bamboo', qmode='bamboo_parity')

@groupsHandler.registerGroup(group=3, score=10)
def group3():
    N = 10**5
    for n in [10**3, 10**4, N]:
        addScript(n=n, q=1, tmode='random', qmode='random')

    for subset in [10, 100, 1000]:
        addScript(n=N, q=1, tmode='looong', groups=N // 17, qmode='small_subset', subset=subset)

    addScript(n=N, q=1, tmode='looong', groups=35, qmode='random')
    addScript(n=N, q=1, tmode='looong', groups=N // 15, qmode='random')
    addScript(n=N, q=1, tmode='bamboo', qmode='random')

@groupsHandler.registerGroup(group=4, score=10)
def group4():
    N = 10**5
    for n in [10**3, 10**4, N]:
        addScript(n=n, q=N, tmode='segtree', qmode='random')

    for subset in [2, 5, 10, 100, 1000]:
        addScript(n=N, q=N, tmode='segtree', qmode='small_subset', subset=subset)

@groupsHandler.registerGroup(group=5, score=10, depends=[3])
def group5():
    N = 10**5
    for n, groups in [(10**3, 14), (10**4, 20), (N, 23)]:
        addScript(n=n, q=min(2 * (n - 1), N), tmode='random', qmode='only_erases')
        addScript(n=n, q=min(2 * (n - 1), N), tmode='looong', groups=n // groups, qmode='only_erases')

    addScript(n=n, q=N, tmode='looong', groups=n // 5, qmode='only_erases')
    addScript(n=n, q=N, tmode='looong', groups=n // 10, qmode='only_erases')
    addScript(n=n, q=N, tmode='looong', groups=n // 30, qmode='only_erases')
    addScript(n=N, q=N, tmode='bamboo', qmode='bamboo_erases')

@groupsHandler.registerGroup(group=6, score=10, depends=range(0, 6))
def group6(N = 10**5):
    for n in [N // 100, N // 10, N]:
        addScript(n=n, q=N, tmode='random', qmode='random')

    addScript(n=n, q=N, tmode='looong', groups=N // 9, qmode='random')
    for subset, groups in zip([2,  5,  10, 100, 1000, 10000],
                              [20, 35, 17, 23,  15,   26]):
        addScript(n=N, q=N, tmode='random', qmode='small_subset', subset=subset)
        addScript(n=N, q=N, tmode='looong', groups=N // groups, qmode='small_subset', subset=subset)

    addScript(n=N, q=N, tmode='bamboo', qmode='bamboo_parity')

@groupsHandler.registerGroup(group=7, score=40, depends=range(0, 7))
def group7():
    group6(N = 3 * 10**5)

if __name__ == '__main__':
    groupsHandler.execute()
