#include <bits/stdc++.h>
using namespace std;

#define fi first
#define se second

const int inf = int(1e9) + 1;

struct SegTree{
    vector<int> tree[2], md; // tree[0] - min, tree[1] - mx
    int n;
    void init(int _n){
        n = _n;
        tree[0].reserve(4 * n), tree[1].reserve(4 * n), md.reserve(4 * n);
        tree[0].assign(4 * n, 0), tree[1].assign(4 * n, 0), md.assign(4 * n, 0);
    }
    void update(int v, int l, int r, int ql, int qr, int x){
        if (max(ql, l) >= min(r, qr)) return;
        if (ql <= l && r <= qr){
            tree[0][v] += x;
            tree[1][v] += x;
            md[v] += x;
            return;
        }
        int m = (l + r) / 2;
        update(2 * v, l, m, ql, qr, x), update(2 * v + 1, m, r, ql, qr, x);
        tree[0][v] = min(tree[0][2 * v], tree[0][2 * v + 1]) + md[v];
        tree[1][v] = max(tree[1][2 * v], tree[1][2 * v + 1]) + md[v];
    }
    void update(int l, int r, int x){
        update(1, 0, n, l, r + 1, x);
    }
    int get_min(int v, int l, int r, int ql, int qr){
        if (max(ql, l) >= min(r, qr)) return inf;
        if (ql <= l && r <= qr) return tree[0][v];
        int m = (l + r) / 2;
        return md[v] + min(get_min(2 * v, l, m, ql, qr), get_min(2 * v + 1, m, r, ql, qr));
    }
    int get_max(int v, int l, int r, int ql, int qr){
        if (max(ql, l) >= min(r, qr)) return -inf;
        if (ql <= l && r <= qr) return tree[1][v];
        int m = (l + r) / 2;
        return md[v] + max(get_max(2 * v, l, m, ql, qr), get_max(2 * v + 1, m, r, ql, qr));
    }
    int get_min(int l, int r){
        return get_min(1, 0, n, l, r + 1);
    }
    int get_max(int l, int r){
        return get_max(1, 0, n, l, r + 1);
    }
};
struct Fenfick{
    vector<int> tree;
    int n;
    void init(int _n){
        n = _n;
        tree.assign(n, 0);
    }
    void update(int pos, int val){
        for (; pos < n; pos |= (pos + 1)) tree[pos] += val;
    }
    int get(int r){
        int s = 0;
        for (; r >= 0; r = (r & (r + 1)) - 1) s += tree[r];
        return s;
    }
    int get(int l, int r){
        return get(r) - get(l - 1);
    }
};
const int N = 3e5 + 1;
vector<int> g[N];
int par[N], cnt[N], dp[N], sz[N], id[N], num[N], depth[N];
vector<vector<int>> path;
vector<int> order;
vector<SegTree> pcnt[2], pdp[2];
vector<Fenfick> is;
void dfs(int v, int p){
    par[v] = p;
    depth[v] = depth[p] + 1;
    for (int u : g[v]){
        if (u != p){
            dfs(u, v);
        }
    }
    for (int ind = 0; ind < g[v].size(); ind++){
        if (g[v][ind] == p){
            swap(g[v][ind], g[v].back());
            g[v].pop_back();
            break;
        }
    }
}
void dfs_dp(int v){
    dp[v] = cnt[v] = 0;
    for (int u : g[v]){
        dfs_dp(u);
        dp[v] += dp[u];
        cnt[v] += cnt[u] == 0;
    }
    dp[v] += cnt[v] != 0;
}
int sizes(int v){
    sz[v] = 1;
    for (int &u : g[v]){
        sz[v] += sizes(u);
        if (sz[u] > sz[g[v][0]]) swap(u, g[v][0]);
    }
    return sz[v];
}
int nxt = 0;
void dfs_hld(int v){
    if (v == 0){
        id[v] = nxt++;
    }
    for (int u : g[v]){
        if (u == g[v][0]){
            id[u] = id[v];
        }
        else{
            id[u] = nxt++;
        }
        dfs_hld(u);
    }
    order.push_back(v);
}
void add_path_dp(int a, int b, int x, int y, int up = 0){
    int head = path[id[a]].back();
    bool between = false;
    if (id[b] != id[a]) between = true;
    else head = b;
    int l = num[a], r = num[head];
    int l0 = (l + 1) / 2, r0 = r / 2;
    int l1 = l / 2, r1 = (r + 1) / 2 - 1;
    if ((up % 2) ^ (num[a] % 2)) swap(x, y);
    pdp[0][id[a]].update(l0, r0, x);
    pdp[1][id[a]].update(l1, r1, y);
    if ((up % 2) ^ (num[a] % 2)) swap(x, y);
    up += r - l + 1;
    if (between){
        add_path_dp(par[head], b, x, y, up);
    }
}
void add_path_cnt(int a, int b, int x, int y, int up = 0){
    int head = path[id[a]].back();
    bool between = false;
    if (id[b] != id[a]) between = true;
    else head = b;
    int l = num[a], r = num[head];
    int l0 = (l + 1) / 2, r0 = r / 2;
    int l1 = l / 2, r1 = (r + 1) / 2 - 1;
    if ((up % 2) ^ (num[a] % 2)) swap(x, y);
    pcnt[0][id[a]].update(l0, r0, x);
    pcnt[1][id[a]].update(l1, r1, y);
    if ((up % 2) ^ (num[a] % 2)) swap(x, y);
    up += r - l + 1;
    if (between){
        add_path_cnt(par[head], b, x, y, up);
    }
}
int get_cnt(int a){
    return pcnt[num[a] % 2][id[a]].get_max(num[a] / 2, num[a] / 2);
}
int get_dp(int a){
    return pdp[num[a] % 2][id[a]].get_max(num[a] / 2, num[a] / 2);
}
int get_path_top(int v){
    int head = path[id[v]].back();
    if (is[id[v]].get(num[v], num[head]) == num[head] - num[v] + 1) return get_path_top(par[head]);
    int left = num[v] - 1, right = num[head];
    while (right - left > 1){
        int mid = (left + right) / 2;
        if (is[id[v]].get(num[v], mid) == mid - num[v] + 1) left = mid;
        else right = mid;
    }
    return path[id[v]][right];
}
int get_last(int cur, int top, int first, int up = 0){
    int head = path[id[cur]].back();
    bool between = false;
    if (id[cur] != id[top]) between = true;
    else head = top;
    int l = num[cur], r = num[head];
    int l0 = (l + 1) / 2, r0 = r / 2;
    int l1 = l / 2, r1 = (r + 1) / 2 - 1;
    int need0 = first, need1 = 1 - first;
    if ((up % 2) ^ (num[cur] % 2)){
        swap(need0, need1);
    }
    int mn0 = pcnt[0][id[cur]].get_min(l0, r0), mx0 = pcnt[0][id[cur]].get_max(l0, r0);
    int mn1 = pcnt[1][id[cur]].get_min(l1, r1), mx1 = pcnt[1][id[cur]].get_max(l1, r1);
    if ((mn0 == need0 || l0 > r0) && (mn1 == need1 || l1 > r1) && (mx1 == need1 || l1 > r1) && (mx0 == need0 || l0 > r0)){
        if (between){
            int res = get_last(par[head], top, first, up + num[head] - num[cur] + 1);
            if (res != -1) head = res;
        }
        return head;
    }
    int left = num[cur] - 1, right = num[head];
    while (right - left > 1){
        int mid = (left + right) / 2;
        l = num[cur], r = mid;
        l0 = (l + 1) / 2, r0 = r / 2;
        l1 = l / 2, r1 = (r + 1) / 2 - 1;
        mn0 = pcnt[0][id[cur]].get_min(l0, r0), mx0 = pcnt[0][id[cur]].get_max(l0, r0);
        mn1 = pcnt[1][id[cur]].get_min(l1, r1), mx1 = pcnt[1][id[cur]].get_max(l1, r1);
        if ((mn0 == need0 || l0 > r0) && (mn1 == need1 || l1 > r1) && (mx1 == need1 || l1 > r1) && (mx0 == need0 || l0 > r0)) left = mid;
        else right = mid;
    }
    if (right != num[cur]) return path[id[cur]][left];
    else return -1;
}
int main(){
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    [[maybe_unused]] int group_index;
    cin >> group_index;
    int n;
    cin >> n;
    vector<pair<int, int>> edg;
    for (int i = 0; i < n - 1; i++){
        int x, y;
        cin >> x >> y;
        x--, y--;
        edg.emplace_back(x, y);
        g[x].push_back(y);
        g[y].push_back(x);
    }
    dfs(0, 0);
    for (int i = 0; i < n - 1; i++){
        if (par[edg[i].fi] != edg[i].se){
            swap(edg[i].fi, edg[i].se);
        }
    }
    dfs_dp(0), sizes(0), dfs_hld(0);
    path.reserve(nxt), path.assign(nxt, vector<int>());
    is.reserve(nxt), is.assign(nxt, Fenfick());
    pdp[0].reserve(nxt), pdp[1].reserve(nxt);
    pdp[0].assign(nxt, SegTree()), pdp[1].assign(nxt, SegTree());
    pcnt[0].reserve(nxt), pcnt[1].reserve(nxt);
    pcnt[0].assign(nxt, SegTree()), pcnt[1].assign(nxt, SegTree());
    for (int i : order){
        num[i] = path[id[i]].size();
        path[id[i]].push_back(i);
    }
    for (int ind = 0; ind < path.size(); ind++){
        int s = path[ind].size();
        pdp[0][ind].init((s + 1) / 2), pcnt[0][ind].init((s + 1) / 2);
        pdp[1][ind].init(s / 2), pcnt[1][ind].init(s / 2);
        for (int i = 0; i < s; i++){
            pdp[i % 2][ind].update(i / 2, i / 2, dp[path[ind][i]]);
            pcnt[i % 2][ind].update(i / 2, i / 2, cnt[path[ind][i]]);
        }
        is[ind].init(s);
        for (int i = 0; i < s; i++){
            is[ind].update(i, path[ind][i] != 0);
        }
    }
    int q;
    cin >> q;
    while (q--){
        int type;
        cin >> type;
        if (type == 1){
            int ind;
            cin >> ind;
            ind--;
            int v = edg[ind].fi;
            if (is[id[v]].get(num[v], num[v])){
                int top = get_path_top(v);
                add_path_dp(par[v], top, -get_dp(v), -get_dp(v));
                is[id[v]].update(num[v], -1);
                if (get_cnt(v) != 0) continue;
                int lst = get_last(par[v], top, 1);
                if (lst == -1){
                    add_path_cnt(par[v], par[v], -1, -1);
                }
                else if (lst == top){
                    add_path_cnt(par[v], top, -1, 1);
                    add_path_dp(par[v], top, -1, 0);
                }
                else{
                    add_path_cnt(par[v], lst, -1, 1);
                    add_path_dp(par[v], lst, -1, 0);
                    if ((depth[par[v]] - depth[lst] + 1) % 2 == 1){
                        add_path_cnt(par[lst], par[lst], 1, 1);
                        add_path_dp(par[lst], top, -1, -1);
                    }
                    else{
                        add_path_cnt(par[lst], par[lst], -1, -1);
                    }
                }
            }
            else{
                is[id[v]].update(num[v], 1);
                int top = get_path_top(v);
                add_path_dp(par[v], top, get_dp(v), get_dp(v));
                if (get_cnt(v) != 0) continue;
                int lst = get_last(par[v], top, 0);
                if (lst == -1){
                    add_path_cnt(par[v], par[v], 1, 1);
                }
                else if (lst == top){
                    add_path_cnt(par[v], top, 1, -1);
                    add_path_dp(par[v], top, 1, 0);
                }
                else{
                    add_path_cnt(par[v], lst, 1, -1);
                    add_path_dp(par[v], lst, 1, 0);
                    if ((depth[par[v]] - depth[lst] + 1) % 2 == 1){
                        add_path_cnt(par[lst], par[lst], -1, -1);
                        add_path_dp(par[lst], top, 1, 1);
                    }
                    else{
                        add_path_cnt(par[lst], par[lst], 1, 1);
                    }
                }
            }
        }
        else{
            int v;
            cin >> v;
            v--;
            cout << get_dp(get_path_top(v)) << "\n";
        }
    }
}
