#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(a) begin(a), end(a)
#define len(a) int((a).size())

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    [[maybe_unused]] int group_index;
    cin >> group_index;

    int n;
    cin >> n;

    vector<pair<int, int>> edges(n - 1);
    vector<set<int>> g(n);
    for (auto &[v, u] : edges) {
        cin >> v >> u;
        v--, u--;
        g[v].insert(u);
        g[u].insert(v);
    }

    int q;
    cin >> q;
    while (q--) {
        int type;
        cin >> type;

        if (type == 1) {
            int edge_id;
            cin >> edge_id;
            edge_id--;

            auto [v, u] = edges[edge_id];
            if (g[v].count(u)) {
                g[v].erase(u);
                g[u].erase(v);
            } else {
                g[v].insert(u);
                g[u].insert(v);
            }
        } else {
            int root;
            cin >> root;
            root--;

            int ans = 0;

            auto dfs = [&](auto &&self, int v, int p) -> bool {
                bool free = true;
                for (auto u : g[v]) {
                    if (u == p) {
                        continue;
                    }
                    if (self(self, u, v) && free) {
                        free = false;
                        ans++;
                    }
                }
                return free;
            };

            dfs(dfs, root, -1);
            cout << ans << '\n';
        }
    }
}
